Subject: I2C Warning on a 405GPr based board with actual 2.6.20-rc5 Kernel

From: Heiko Schocher <[email-masked]>
Date: Wed, 17 Jan 2007 16:10:09 +0100

Hello,

I have a 405Gpr based Board and use the I2C Bus. Today I tried the Linux
Kernel version 2.6.20-rc5, and get the following Warning:

i2c /dev entries driver
IBM IIC driver v2.1
**WARNING** I2C adapter driver [IBM IIC] forgot to specify physical
device; fix it!
ibm-iic0: using standard (100 kHz) mode

Hmm.. I solved it with the following patch, but I don t know if this is
the right way.

diff --git a/drivers/i2c/busses/i2c-ibm_iic.c
b/drivers/i2c/busses/i2c-ibm_iic.c
index 1898e99..140d7fe 100644
--- a/drivers/i2c/busses/i2c-ibm_iic.c
+++ b/drivers/i2c/busses/i2c-ibm_iic.c
@@ -35,6 +35,7 @@
 #include <linux/slab.h>
 #include <linux/init.h>
 #include <linux/interrupt.h>
+#include <linux/platform_device.h>
 #include <asm/irq.h>
 #include <asm/io.h>
 #include <linux/i2c.h>
@@ -737,6 +738,9 @@ static int __devinit iic_probe(struct ocp_device
*ocp){
 	adap->timeout = 1;
 	adap->retries = 1;
 
+	if (adap->dev.parent == NULL) {
+		adap->dev.parent = &platform_bus;
+	}
 	if ((ret = i2c_add_adapter(adap)) != 0){
 		printk(KERN_CRIT "ibm-iic%d: failed to register i2c adapter\n",
 			dev->idx);

thanks
Heiko